# CHTML

<!-- BADGES/ -->

<span class="badge-npmversion"><a href="https://npmjs.org/package/@web-native-js/chtml" title="View this project on NPM"><img src="https://img.shields.io/npm/v/@web-native-js/chtml.svg" alt="NPM version" /></a></span>
<span class="badge-npmdownloads"><a href="https://npmjs.org/package/@web-native-js/chtml" title="View this project on NPM"><img src="https://img.shields.io/npm/dm/@web-native-js/chtml.svg" alt="NPM downloads" /></a></span>

<!-- /BADGES -->


CHTML is a suite of new DOM features that brings native support for modern UI development paradigms: a component-based architecture, data binding, and reactivity. This lets us build elegant user interfaces using the web platform itself.

> CHTML is being proposed as a [W3C standard at the Web Platform Incubator Community Group](https://discourse.wicg.io/t/proposal-chtml/4716) based on [this explainer](https://github.com/web-native/chtml/blob/master/explainer.md).

[Check this project out on GitHub](https://github.com/web-native/chtml).

## Documentation

+ [Scoped HTML](https://docs.web-native.dev/chtml/scoped-html) - Structure your document as a hierarchy of *scopes* and *subscopes*.
+ [Scoped CSS](https://docs.web-native.dev/chtml/scoped-css) - Define styling as part of any element using scoped stylesheets.
+ [Scoped JS](https://docs.web-native.dev/chtml/scoped-js) - Define behaviour as part of any element using scoped scripts.
+ [HTML Partials](https://docs.web-native.dev/chtml/html-partials) - Define, import/export, and compose with reusable HTML snippets.

## Getting Started

+ [Installation](https://docs.web-native.dev/chtml/installation) - Follow the installation guide to add the CHTML polyfill to your page.
+ [Examples](https://docs.web-native.dev/chtml/examples) - Get a head start with these few examples.

## Issues

To report bugs or request features, please submit an [issue](https://github.com/web-native/chtml/issues).

## License

MIT.
